{ TExtMemo version 1.0 copyright  1996 by Alexander Meeder

  This visual component is derived from the TMemo-component. You can now 'undo' your
  last edit-action and you can get the cursor-position.

  properties (read-/runtimeonly):
  * LinePos -> Current line-position of carret
  * CharPos -> Current character-position on line of carret
  * LineLenght -> Length of line with carret on it

  methods:
  * Undo -> ExtMemo1.Undo

  If you have suggestions about TExtMemo or make changes, pleas mail me: ameeder@dds.nl
}
unit extmemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TExtMemo = class(TMemo)
  private
    FLinePos    : integer;
    FCharPos    : integer;
    FLineLength : integer;

    procedure Update;
  protected
    procedure Click; override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure Undo;
  published
    property CharPos : integer read FCharPos;
    property LineLength : integer read FLineLength;
    property LinePos : integer read FLinePos;
  end;

procedure Register;

implementation

procedure TExtMemo.Update;
begin
  if not (csDesigning in ComponentState) then
  begin
    FLinePos := perform(EM_LINEFROMCHAR, SelStart, 0);
    FCharPos := perform(EM_LINEINDEX, FLinePos, 0);
    FLineLength := perform(EM_LINELENGTH, FCharPos, 0);
    FLinePos := FLinePos + 1;
    FCharPos := (SelStart - FCharPos) + 1;
  end;
end;

procedure TExtMemo.Undo;
begin
  if modified then perform(WM_UNDO, 0, 0);
end;

procedure TExtMemo.Click;
begin
  update;
  inherited Click;
end;

procedure TExtMemo.KeyUp(var Key: Word; Shift: TShiftState);
begin
  update;
  inherited KeyUp(Key, Shift);
end;

constructor TExtMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure Register;
begin
  RegisterComponents('Samples', [TExtMemo]);
end;

end.
