{ TOMenu component version 1.0, copyright  A. Meeder, 1996

  ** It's freeware, so you don't have to pay me, but I do not guarantee the working of it

  This component simplyfies the proces of adding glyphs to menu's (MainMenu and Popup).
  Make sure the bitmaps are the following size: 14 x 14 pixels
  Drop this component on the form set the following properties:
  * CheckGlyph (bitmap) when you use the 'checked' property of the menuitem
  * Glyph (bitmap) the basic glyph or the 'Unchecked' glyph when you use the checked property
  * Item (MenuItem) select the menuitem to place the Glyph

  There is one method:
  * refresh, you must call this method when the menuitem.checked property changes

  If you have suggestions about TOMenu or make changes, please mail me: ameeder@dds.nl
}

unit Omenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Menus;

type
  TBMItem = class(TComponent)
  private
    { Private declarations }
    FGlyph: TBitmap;
    FCheckGlyph: TBitmap;
    FMenuItem: TMenuItem;

    procedure SetGlyph(value: TBitmap);
    procedure SetCheckGlyph(value: TBitmap);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh;
    procedure Loaded; override;
  published
    { Published declarations }
    property CheckGlyph: TBitmap read FCheckGlyph write SetCheckGlyph;
    property Glyph: TBitmap read FGlyph write SetGlyph;
    property MenuItem: TMenuItem read FMenuItem write FMenuItem;
  end;

procedure Register;

implementation

procedure TBMItem.SetGlyph(value: TBitmap);
begin
  FGlyph.Assign(value);
end;

procedure TBMItem.SetCheckGlyph(value: TBitmap);
begin
  FCheckGlyph.Assign(value);
end;

procedure TBMItem.Refresh;
begin
  if (FMenuItem <> nil) then
  begin
    if (FMenuItem.Checked) and (FCheckGlyph <> nil) then
       SetMenuItemBitmaps(FMenuItem.Parent.Handle, FMenuItem.Command, MF_BYCOMMAND, FGlyph.Handle, FCheckGlyph.Handle)
    else
      if (FGlyph <> nil) then
         SetMenuItemBitmaps(FMenuItem.Parent.Handle, FMenuItem.Command, MF_BYCOMMAND, FGlyph.Handle, FGlyph.Handle);
  end;
end;

procedure TBMItem.Loaded;
begin
  inherited Loaded;
  Refresh;
end;

constructor TBMItem.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCheckGlyph := TBitmap.Create;
  FGlyph := TBitmap.Create;
end;

destructor TBMItem.Destroy;
begin
  FCheckGlyph.Free;
  FGlyph.Free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Win95', [TBMItem]);
end;

end.
