{ TTopMost verion 1.0 copyright  1996 by Alexander Meeder

  This non-visual component is build round the Windows 'SetWindowPos' API, maybe you noticed
  that when you change the Form1.FormStyle from 'fsNormal' <-> 'fsStayOnTop' the form will
  flicker. This is not the case when you use this component.

  properties:
  * StayOnTop (true/false);

  If you have suggestions about TTopMost or make changes, pleas mail me: ameeder@dds.nl
}

unit TopMost;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms;

type
  TTopMost = class(TComponent)
  private
    FTopMost: boolean;

    procedure SetTopMost(value: boolean);
    procedure Activate;
  protected
    OwnerHandle: HWND;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property TopMost: boolean read FTopMost write SetTopMost default true;
  end;

procedure Register;

implementation

procedure TTopMost.Activate;
begin
  if not (csDesigning in ComponentState) and (FTopMost) then
     SetWindowPos(OwnerHandle, hwnd_TopMost, 0, 0, 0, 0, swp_NoMove + swp_NoSize)
  else
     SetWindowPos(OwnerHandle, hwnd_NoTopMost, 0, 0, 0, 0, swp_NoMove + swp_NoSize);
end;

procedure TTopMost.SetTopMost(value: boolean);
begin
  if value <> FTopMost then
  begin
    FTopMost := value;
    Activate;
  end;
end;

constructor TTopMost.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTopMost := true;
  OwnerHandle := (AOwner as TForm).Handle;
  Activate;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TTopMost]);
end;

end.
